#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "netmon_std.h"

/* network monitor
 * Monitors the bytes of traffic on a network device
 * 2006-05-14 ed AT s5h DOT net - version 0.1 beta code
 * Use at your own risk. Author not responsible for use.
 *
 * Updates at http://www.s5h.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */


void print_list( struct interface_line *p, struct interface_line *pp, \
		struct interface_line *min ) {

	while( p != NULL ) {
		if( pp == NULL ) {
			pp = p;
		}

		printf( 
	
"%6s I:%4dMiB O:%4dMiB | I:%4dKiB O:%4dKiB | I:%4dKiB O:%4dKiB\n",

			p->name, p->ibytes/1024/1024, p->obytes/1024/1024,
			(p->ibytes-pp->ibytes)/1024, 
			(p->obytes-pp->obytes)/1024,
			(p->ibytes-min->ibytes)/1024,
			(p->obytes-min->obytes)/1024 );

		p=p->next;
		pp=pp->next;
		min=min->next;
	}

	printf( "\n\n" );
}


void interface_cycle() {
	struct interface_line *il, *ll, *min/*,*temp*/;
	int count = 0;

	ll = getinterfaces();
	min = getinterfaces();
	while( 1 ) {
	
/*		temp=ll;
		while( temp!=NULL ) {
			printf( "IF: %s\n", temp->name );
			temp=temp->next;
		} */

		il = getinterfaces();

		printf( "   [:: running total ::]   |  [:: reset/sec ::]  |  [:: reset/min ::]\n" );

		print_list( il, ll, min );

		freeinterfaces(ll);
		if( count++ == 60 ) {
			count = 0;
			freeinterfaces(min);
			min = getinterfaces();
		}
		ll = il;
		usleep( 1000000 );
	}
}


int main() {
	interface_cycle();
	return( EXIT_SUCCESS );
}

